#include "ot4xb.ch"
//-------------------------------------------------------------------------------------------------------------------------
proc appsys();return
//-------------------------------------------------------------------------------------------------------------------------
proc main()
local aList := aGetTaskBarWindows()
if Empty(aList)
   MsgBox( "Empty List" )
else
   DlgABrw( aList,"List Windows in the TaskBar",;
            { "HWND      ","Title                     ",;
              "ThreadId  ","ProcessId ","Process Name"},;
              {|aPos,u,oBrw| u := oBrw:GetData() , iif(Empty(u),,;
              @user32:FlashWindowEx({20,aList[u][1],3,10,500} ));
              })
end
return
//-------------------------------------------------------------------------------------------------------------------------
function WndEnumProc( hWnd , cona )
local aInfo := Array(5)
local n := @user32:GetWindowTextLengthA(hWnd)
local c                                      
if (n == 0 ) ; return .T. ; end
if (@user32:GetWindow(hWnd,4) != 0) ; return .T. ; end
if (@user32:GetParent(hWnd) != 0) ; return .T. ; end
if( @user32:IsWindowVisible(hWnd) == 0) ; return .T. ; end
if( lAnd( @user32:GetWindowLongA(hWnd, -20) , 0x80) ) ; return .T. ; end

aInfo[1] := hWnd
c := ChrR(0,n)
@user32:GetWindowTextA(hWnd,@c,Len(c)+1)
aInfo[2] := c
n := 0
aInfo[3] := @user32:GetWindowThreadProcessId(hWnd,@n)
aInfo[4] := n
c := ChrR(0,260)
aInfo[5] := cPid2ModName(aInfo[4] )
aadd( _con2var(cona) , aInfo )
return .T.
//-------------------------------------------------------------------------------------------------------------------------
function aGetTaskBarWindows()
local aWnd := {}
local cona := _var2con(aWnd)
@user32:EnumWindows(_callback_WndEnumProc(),cona)
_conRelease(cona)
return aWnd
//-------------------------------------------------------------------------------------------------------------------------
static function cPid2ModName( nPid )
local hProcess := @kernel32:OpenProcess(0x410,.F.,nPid)
local cName    := Chrr(0,512)
local hMod     := 0
local cbn      := 0
if( !Empty(hProcess) )
   if( @psapi:EnumProcessModules(hProcess,@hMod,4,@cbn) != 0 )
      @psapi:GetModuleBaseNameA(hProcess,hMod,@cName, Len(cName))
   end
   @kernel32:CloseHandle(hProcess)
end
return TrimZ(cName)
